/// @description backbone

randomize();

arr_player[0] = instance_create_layer(0,0,"Instances",obj_sub);
arr_player[0].hp = 3;
arr_player[0].lst_moves = ds_list_create();
arr_player[0].lst_move_log = ds_list_create();
arr_player[0].sprite_index = spr_sub_1;
arr_player[0].aim_direc = AIM_NORTH;
arr_player[1] = instance_create_layer(0,0,"Instances",obj_sub);
arr_player[1].hp = 3;
arr_player[1].lst_moves = ds_list_create();
arr_player[1].lst_move_log = ds_list_create();
arr_player[1].sprite_index = spr_sub_2;
arr_player[1].aim_direc = AIM_NORTH;
arr_player[1].visible = false;

obj_track_p1.visible = true;
obj_track_p2.visible = false;

players_turn = PLAYER_1;
game_state = STT_UPKEEP;

move_north_pressed = false;
move_west_pressed = false;
move_south_pressed = false;
move_east_pressed = false;
fire_pressed = false;
emerge_pressed = false;
undo_pressed = false;

for (var i = 0; i < MAP_VER; ++i)
{
    for (var j = 0; j < MAP_HOR; ++j)
	{
		mx_map[i,j] = TILE_SEA;
	}
}

reef_number = random_range(REEF_NUMBER_MIN, REEF_NUMBER_MAX);

for (var i = 0; i < reef_number; ++i) {
	var rnd_x = random_range(0, MAP_VER-1);
	var rnd_y = random_range(0, MAP_HOR-1);
    mx_map[rnd_x,rnd_y] = TILE_REEF;
}

var rnd_x = random_range(0, MAP_VER-1);
var rnd_y = random_range(0, MAP_HOR-1);

while(mx_map[rnd_x,rnd_y] == TILE_REEF)
{
	rnd_x = random_range(0, MAP_VER-1);
	rnd_y = random_range(0, MAP_HOR-1);
}

mx_map[rnd_x,rnd_y] = PLAYER_1;

while(mx_map[rnd_x,rnd_y] == TILE_REEF || mx_map[rnd_x,rnd_y] == PLAYER_1)
{
	rnd_x = random_range(0, MAP_VER-1);
	rnd_y = random_range(0, MAP_HOR-1);
}

mx_map[rnd_x,rnd_y] = PLAYER_2;

// i know i could write all in just one FOR, don't judge me

for (var i = 0; i < MAP_VER; ++i)
{
    for (var j = 0; j < MAP_HOR; ++j)
	{
		    instance_create_layer(MARGIN_LEFT+i*TILE_SIZE, MARGIN_TOP+j*TILE_SIZE,"Sea",obj_sea);
	}
}

for (var i = 0; i < MAP_VER; ++i)
{
    for (var j = 0; j < MAP_HOR; ++j)
	{
		if (mx_map[j,i] == TILE_REEF)
		{
			instance_create_layer(MARGIN_LEFT+i*TILE_SIZE, MARGIN_TOP+j*TILE_SIZE,"Reefs",obj_reef);
		}
	}
}

for (var i = 0; i < MAP_VER; ++i)
{
    for (var j = 0; j < MAP_HOR; ++j)
	{
		if (mx_map[j,i] == PLAYER_1)
		{
			arr_player[PLAYER_1].pos_x = i;
			arr_player[PLAYER_1].pos_y = j;
			arr_player[PLAYER_1].temp_pos_x = i;
			arr_player[PLAYER_1].temp_pos_y = j;
			arr_player[PLAYER_1].x = MARGIN_LEFT+i*TILE_SIZE;
			arr_player[PLAYER_1].y = MARGIN_TOP+j*TILE_SIZE;
		}
		else if (mx_map[j,i] == PLAYER_2)
		{
			arr_player[PLAYER_2].pos_x = i;
			arr_player[PLAYER_2].pos_y = j;
			arr_player[PLAYER_2].temp_pos_x = i;
			arr_player[PLAYER_2].temp_pos_y = j;
			arr_player[PLAYER_2].x = MARGIN_LEFT+i*TILE_SIZE;
			arr_player[PLAYER_2].y = MARGIN_TOP+j*TILE_SIZE;
		}
	}
}
