/// @description Insert description here
// You can write your code in this editor

/*
1. mantenimiento
	- mostrar submarino de jugador de turno
	- pintar recorrido enemigo
	- resetear botones
2. acciones
	2.1 movimiento 1,2,3,4
		- puede haber UNDO
		- cierra en FIRE
	2.2 emerger
		- ningun movimiento vale
		- resetea log
4. fin de turno
	- esconder tu submarino
	- esconder recorrido enemigo
	- mostrar pantalla de transición hotseat
*/
if (keyboard_check_pressed(vk_f12))
{
	room_restart();
}
if (keyboard_check_pressed(vk_f11))
{
	var str = "";
	for (var i = 0; i < ds_list_size(arr_player[players_turn].lst_move_log); ++i) {
	    str += ds_list_find_value(arr_player[players_turn].lst_move_log, i) + ",";
	}
	show_debug_message(str);
}
if (keyboard_check_pressed(vk_f10))
{
	var str = "";
	var enemy = players_turn;
	if (enemy == PLAYER_1)
	{
		enemy = PLAYER_2;
	}
	else 
	{
		enemy = PLAYER_1;
	}
	for (var i = 0; i < ds_list_size(arr_player[enemy].lst_move_log); ++i) {
	    str += ds_list_find_value(arr_player[enemy].lst_move_log, i) + ",";
	}
	show_debug_message(str);
}
if (keyboard_check_pressed(vk_f9))
{
	show_debug_message("P1:"+string(arr_player[PLAYER_1].pos_x)+","+string(arr_player[PLAYER_1].pos_y)
		+" - P2:"+string(arr_player[PLAYER_2].pos_x)+","+string(arr_player[PLAYER_2].pos_y));
}
if (keyboard_check_pressed(vk_f8))
{
	show_debug_message("P1:"+string(arr_player[PLAYER_1].hp)+" vs "+string(arr_player[PLAYER_2].hp));
}

if (mouse_check_button_pressed(mb_any) && position_meeting(mouse_x,mouse_y,obj_btn_up) )
{
	move_north_pressed = true;
}
if (mouse_check_button_pressed(mb_any) && position_meeting(mouse_x,mouse_y,obj_btn_left) )
{
	move_west_pressed = true;
}
if (mouse_check_button_pressed(mb_any) && position_meeting(mouse_x,mouse_y,obj_btn_down) )
{
	move_south_pressed = true;
}
if (mouse_check_button_pressed(mb_any) && position_meeting(mouse_x,mouse_y,obj_btn_right) )
{
	move_east_pressed = true;
}
if (mouse_check_button_pressed(mb_any) && position_meeting(mouse_x,mouse_y,obj_btn_undo))
{
	undo_pressed = true;
}
if (mouse_check_button_pressed(mb_any) && position_meeting(mouse_x,mouse_y,obj_btn_emerge))
{
	emerge_pressed = true;
}
if (mouse_check_button_pressed(mb_any) && position_meeting(mouse_x,mouse_y,obj_btn_fire))
{
	fire_pressed = true;
}

if (keyboard_check_pressed(vk_up)) move_north_pressed = true;
if (keyboard_check_pressed(vk_left)) move_west_pressed = true;
if (keyboard_check_pressed(vk_down)) move_south_pressed = true;
if (keyboard_check_pressed(vk_right)) move_east_pressed = true;
if (keyboard_check_pressed(vk_backspace)) undo_pressed = true;
if (keyboard_check_pressed(vk_space)) emerge_pressed = true;
if (keyboard_check_pressed(vk_enter)) fire_pressed = true;

switch (game_state) {
    case STT_UPKEEP:
		show_debug_message("upkeep");
		arr_player[players_turn].visible = true;
		if (obj_track_p1.visible == true)
		{
			obj_track_p1.visible = false;
			obj_track_p2.visible = true;
		}
		else
		{
			obj_track_p1.visible = true;
			obj_track_p2.visible = false;
		};
		game_state = STT_MOVE;
        break;
	case STT_MOVE:
		if (move_north_pressed && ds_list_size(arr_player[players_turn].lst_moves) < ACTIONS_NUMBER)
		{
			if (scr_check_move_on_log(arr_player[players_turn].lst_move_log,
					arr_player[players_turn].temp_pos_x,
					arr_player[players_turn].temp_pos_y - 1))
			{
				show_debug_message("can't go north cuz you already went that way ");
			}
			else if(arr_player[players_turn].temp_pos_y - 1 < 0)
			{
				show_debug_message("can't go north cuz limits ");
			}
			else if (mx_map[arr_player[players_turn].temp_pos_y - 1,arr_player[players_turn].temp_pos_x] == TILE_REEF)
			{
				show_debug_message("can't go north cuz reef "+
					string(arr_player[players_turn].temp_pos_x) + "," + string(arr_player[players_turn].temp_pos_y - 1));
			}
			else
			{
				arr_player[players_turn].temp_pos_y -= 1;
				ds_list_add(arr_player[players_turn].lst_moves, MOVE_NORTH);
				ds_queue_enqueue(arr_player[players_turn].que_move_anim, MOVE_NORTH);
			}
		}
		if (move_west_pressed && ds_list_size(arr_player[players_turn].lst_moves) < ACTIONS_NUMBER)
		{
			if (scr_check_move_on_log(arr_player[players_turn].lst_move_log,
					arr_player[players_turn].temp_pos_x - 1,
					arr_player[players_turn].temp_pos_y))
			{
				show_debug_message("can't go west cuz you already went that way ");
			}
			else if(arr_player[players_turn].temp_pos_x - 1 < 0)
			{
				show_debug_message("can't go west");
			}
			else if (mx_map[arr_player[players_turn].temp_pos_y,arr_player[players_turn].temp_pos_x-1] == TILE_REEF)
			{
				show_debug_message("can't go west cuz reef "+
					string(arr_player[players_turn].temp_pos_x-1) + "," + string(arr_player[players_turn].temp_pos_y));
			}
			else
			{
				arr_player[players_turn].temp_pos_x -= 1;
				ds_list_add(arr_player[players_turn].lst_moves, MOVE_WEST);
				ds_queue_enqueue(arr_player[players_turn].que_move_anim, MOVE_WEST);
			}
		}
		if (move_south_pressed && ds_list_size(arr_player[players_turn].lst_moves) < ACTIONS_NUMBER)
		{
			if (scr_check_move_on_log(arr_player[players_turn].lst_move_log,
					arr_player[players_turn].temp_pos_x,
					arr_player[players_turn].temp_pos_y + 1))
			{
				show_debug_message("can't go south cuz you already went that way ");
			}
			else if(arr_player[players_turn].temp_pos_y + 1 == MAP_VER)
			{
				show_debug_message("can't go south");
			}
			else if (mx_map[arr_player[players_turn].temp_pos_y + 1,arr_player[players_turn].temp_pos_x] == TILE_REEF)
			{
				show_debug_message("can't go south cuz reef "+
					string(arr_player[players_turn].temp_pos_x) + "," + string(arr_player[players_turn].temp_pos_y + 1));
			}
			else
			{
				arr_player[players_turn].temp_pos_y += 1;
				ds_list_add(arr_player[players_turn].lst_moves, MOVE_SOUTH);
				ds_queue_enqueue(arr_player[players_turn].que_move_anim, MOVE_SOUTH);
			}
		}
		if (move_east_pressed && ds_list_size(arr_player[players_turn].lst_moves) < ACTIONS_NUMBER)
		{
			if (scr_check_move_on_log(arr_player[players_turn].lst_move_log,
					arr_player[players_turn].temp_pos_x+1,
					arr_player[players_turn].temp_pos_y))
			{
				show_debug_message("can't go east cuz you already went that way ");
			}
			else if(arr_player[players_turn].temp_pos_x + 1 == MAP_HOR)
			{
				show_debug_message("can't go east");
			}
			else if (mx_map[arr_player[players_turn].temp_pos_y,arr_player[players_turn].temp_pos_x+1] == TILE_REEF)
			{
				show_debug_message("can't go east cuz reef "+
					string(arr_player[players_turn].temp_pos_x+1) + "," + string(arr_player[players_turn].temp_pos_y));
			}
			else
			{
				arr_player[players_turn].temp_pos_x += 1;
				ds_list_add(arr_player[players_turn].lst_moves, MOVE_EAST);
				ds_queue_enqueue(arr_player[players_turn].que_move_anim, MOVE_EAST);
			}
		}
		
		if (fire_pressed && ds_list_size(arr_player[players_turn].lst_moves) == ACTIONS_NUMBER)
		{
			show_debug_message("choose your fire line!");
			game_state = STT_FIRE;
		}
		
		if (undo_pressed)
		{
			if (ds_list_size(arr_player[players_turn].lst_moves) == 0)
			{
				show_debug_message("nothing to undo");
			}
			else
			{
				var last_move = ds_list_find_value(arr_player[players_turn].lst_moves, ds_list_size(arr_player[players_turn].lst_moves)-1);
				ds_list_delete(arr_player[players_turn].lst_moves, ds_list_size(arr_player[players_turn].lst_moves)-1);
				show_debug_message("undoing " + scr_direc2str(last_move));
				switch (last_move) {
				    case MOVE_NORTH:
				        arr_player[players_turn].temp_pos_y += 1;
						ds_queue_enqueue(arr_player[players_turn].que_move_anim, MOVE_SOUTH);
				        break;
					case MOVE_WEST:
						arr_player[players_turn].temp_pos_x += 1;
						ds_queue_enqueue(arr_player[players_turn].que_move_anim, MOVE_EAST);
						break;
					case MOVE_SOUTH:
						arr_player[players_turn].temp_pos_y -= 1;
						ds_queue_enqueue(arr_player[players_turn].que_move_anim, MOVE_NORTH);
						break;
					case MOVE_EAST:
						arr_player[players_turn].temp_pos_x -= 1;
						ds_queue_enqueue(arr_player[players_turn].que_move_anim, MOVE_WEST);
						break;
				    default:
				        show_debug_message("ERROR AT UNDO");
				        break;
				}
				show_debug_message("not really, undo pls! new queue size: "+string(ds_list_size(arr_player[players_turn].lst_moves)));	
			}
		};
		if (emerge_pressed)
		{
			game_state = STT_EMERGE;
		};
		break;
	case STT_FIRE:
		show_debug_message("AIM AND FIRE!");
		while(0 < ds_list_size(arr_player[players_turn].lst_moves))
		{
			var direc = ds_list_find_value(arr_player[players_turn].lst_moves, 0);
			switch (direc) {
				case MOVE_NORTH:
				    arr_player[players_turn].pos_y -= 1;
					ds_list_add(arr_player[players_turn].lst_move_log,
						scr_pos2str(arr_player[players_turn].pos_x,arr_player[players_turn].pos_y));
				    break;
				case MOVE_WEST:
					arr_player[players_turn].pos_x -= 1;
					ds_list_add(arr_player[players_turn].lst_move_log,
						scr_pos2str(arr_player[players_turn].pos_x,arr_player[players_turn].pos_y));
					break;
				case MOVE_SOUTH:
					arr_player[players_turn].pos_y += 1;
					ds_list_add(arr_player[players_turn].lst_move_log,
						scr_pos2str(arr_player[players_turn].pos_x,arr_player[players_turn].pos_y));
					break;
				case MOVE_EAST:
					arr_player[players_turn].pos_x += 1;
					ds_list_add(arr_player[players_turn].lst_move_log,
						scr_pos2str(arr_player[players_turn].pos_x,arr_player[players_turn].pos_y));
					break;
				default:
				    break;
			}
			ds_list_delete(arr_player[players_turn].lst_moves,0);
			show_debug_message(scr_direc2str(direc));
		}
		
		if(arr_player[players_turn].has_moved)
		{
			obj_aim.visible = true;
			// select where to fire and fire goddammit
			// mostrar aim hacia el norte
			if (move_north_pressed)
			{
				arr_player[players_turn].aim_direc = AIM_NORTH;
			}
			
			if (move_west_pressed)
			{
				arr_player[players_turn].aim_direc = AIM_WEST;
			}
			
			if (move_south_pressed)
			{
				arr_player[players_turn].aim_direc = AIM_SOUTH;
			}
			
			if (move_east_pressed)
			{
				arr_player[players_turn].aim_direc = AIM_EAST;
			}
			
			if (fire_pressed)
			{
				arr_player[players_turn].has_fired = true;
				arr_player[players_turn].has_finished = false;
				instance_create_layer(
					MARGIN_LEFT+arr_player[players_turn].pos_x*TILE_SIZE,
					MARGIN_TOP+arr_player[players_turn].pos_y*TILE_SIZE,
					"Instances", obj_torpedo)
			}
			
			if (arr_player[players_turn].has_fired)
			{
				obj_aim.visible = false;
				if(arr_player[players_turn].has_finished)
				{
					var _trans = instance_create_depth(0, 0, -10000, obj_transition);
					_trans.player = players_turn + 1;
					game_state = STT_TRANSITION;
				}
			}
		}
		break;
	case STT_EMERGE:
		show_debug_message("STT_EMERGE");
		ds_list_clear(arr_player[players_turn].lst_move_log);
		ds_list_clear(arr_player[players_turn].lst_moves);
		var _trans = instance_create_depth(0, 0, -10000, obj_transition);
		_trans.player = players_turn + 1;
		game_state = STT_TRANSITION;
		break;
	case STT_TRANSITION:
		if !instance_exists(obj_transition) {
			game_state = STT_EOT;
		}
		break;
	case STT_EOT:
		show_debug_message("STT_EOT");
        arr_player[players_turn].visible = false;
		arr_player[players_turn].enemy_track_visible = false;
		arr_player[players_turn].has_moved = false;
		arr_player[players_turn].has_fired = false;
		if (players_turn == PLAYER_2)
		{
		    players_turn = PLAYER_1;
		}
		else
		{
			players_turn = PLAYER_2;
		}
		
		game_state = STT_UPKEEP;
        break;
    default:
        break;
}

// 



// reset presseds
move_north_pressed = false;
move_west_pressed = false;
move_south_pressed = false;
move_east_pressed = false;
undo_pressed = false;
fire_pressed = false;
emerge_pressed = false;
